﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="RadGridBatchEditingAndRelatedComboBoxes.aspx.cs" Inherits="RadGridBatchEditingAndRelatedComboBoxes" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <telerik:RadScriptBlock runat="server">
        <script type="text/javascript">
            var isRequestingItems = false;
            var isSelectedIndexChangedInProgress = false;
            var setDefaultValue = false;
            var lastEditedRow;

            function DropDownOpening(sender, args) {
                // Required to force the creation of the data items
                $find("<%= RadGrid1.ClientID %>").get_masterTableView().get_dataItems();

                var row = Telerik.Web.UI.Grid.GetFirstParentByTagName(sender.get_element(), "tr");

                var value = $find(row.id).get_cell("Continent").children[0].innerHTML.trim();

                var comboBox = $telerik.findControl($get("<%= RadGrid1.ClientID %>"), "RadComboBox1");
                var item = comboBox.findItemByText(value);
                // item will be null when the first combobox item is not loaded. The behavior is caused from the
                // turned on LoadOnDemand feature on the first combobox
                if (item) {
                    var id = item.get_value();
                }

                setDefaultValue = false;
                requestItems(sender, value);
            }

            function SelectedIndexChanged(sender, args) {
                if (isSelectedIndexChangedInProgress) {
                    return;
                }
                isSelectedIndexChangedInProgress = true;
                var row = Telerik.Web.UI.Grid.GetFirstParentByTagName(sender.get_element(), "tr");
                var comboBox = $telerik.findControl($get("<%= RadGrid1.ClientID %>"), "RadComboBox2");
                if (args.get_item()) {
                    setDefaultValue = true;
                    requestItems(comboBox, args.get_item().get_text());
                }
                isSelectedIndexChangedInProgress = false;
            }

            function ItemsRequested(sender, args) {
                // Required to force the creation of the data items
                $find("<%= RadGrid1.ClientID %>").get_masterTableView().get_dataItems();
                var td = $find(lastEditedRow.id).get_cell("Country");
                if (setDefaultValue) {
                    $find("<%= RadGrid1.ClientID %>").get_batchEditingManager().changeCellValue(td, sender.get_items().getItem(0).get_text());
                    setDefaultValue = false;
                }
            }

            function ItemsRequesting(sender, args) {
                args.set_cancel(!isRequestingItems);
            }

            function requestItems(combo, value) {
                isRequestingItems = true;
                combo.requestItems(value);
                isRequestingItems = false;
            }

            function Opening(sender, args) {
                isSelectedIndexChangedInProgress = true;
                lastEditedRow = args.get_row();
            }

            function Opened() {
                isSelectedIndexChangedInProgress = false;
            }

            function Closing() {
                isSelectedIndexChangedInProgress = true;
            }

            function Closed() {
                isSelectedIndexChangedInProgress = false;
            }

            function pageLoad() {
                var combo = $telerik.findControl($get("<%= RadGrid1.ClientID %>"), "RadComboBox1");
                requestItems(combo);
            }
        </script>
    </telerik:RadScriptBlock>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <style>
                div.RadPivotGrid .rpgWrap {
                    direction: ltr;
                }

                div.RadPivotGrid th,
                div.RadPivotGrid td,
                div.RadPivotGrid .rpgOuterTableWrapper td {
                    text-align: right;
                }
            </style>
            <telerik:RadScriptManager runat="server"></telerik:RadScriptManager>
            <telerik:RadGrid ID="RadGrid1" runat="server" OnNeedDataSource="RadGrid1_NeedDataSource" AutoGenerateColumns="false"
                OnBatchEditCommand="RadGrid1_BatchEditCommand">
                <ClientSettings>
                    <ClientEvents OnBatchEditClosed="Closed" OnBatchEditClosing="Closing" OnBatchEditOpened="Opened" OnBatchEditOpening="Opening" />
                </ClientSettings>
                <MasterTableView EditMode="Batch" CommandItemDisplay="Top">
                    <BatchEditingSettings EditType="Cell" />
                    <Columns>
                        <telerik:GridTemplateColumn UniqueName="Continent" DataField="Continent">
                            <ItemTemplate>
                                <%# Eval("Continent") %>
                            </ItemTemplate>
                            <EditItemTemplate>
                                <telerik:RadComboBox ID="RadComboBox1" runat="server" OnItemsRequested="RadComboBox1_ItemsRequested"
                                    OnClientSelectedIndexChanged="SelectedIndexChanged"
                                    
                                    EnableLoadOnDemand="true" ShowMoreResultsBox="true"
                                    EnableVirtualScrolling="true" OnClientItemsRequesting="ItemsRequesting">
                                </telerik:RadComboBox>
                            </EditItemTemplate>
                        </telerik:GridTemplateColumn>
                        <telerik:GridTemplateColumn UniqueName="Country" DataField="Country">
                            <ItemTemplate>
                                <%# Eval("Country") %>
                            </ItemTemplate>
                            <EditItemTemplate>
                                <telerik:RadComboBox ID="RadComboBox2" runat="server"
                                    OnItemsRequested="RadComboBox2_ItemsRequested" EnableLoadOnDemand="true"
                                    ShowMoreResultsBox="true" OnClientDropDownOpening="DropDownOpening"
                                    OnClientItemsRequested="ItemsRequested"
                                    EnableVirtualScrolling="true" OnClientItemsRequesting="ItemsRequesting">
                                </telerik:RadComboBox>
                            </EditItemTemplate>
                        </telerik:GridTemplateColumn>
                    </Columns>
                </MasterTableView>
            </telerik:RadGrid>
        </div>
    </form>
</body>
</html>
